using System;
using System.Collections;
using System.Text;

using Cosmos.UserFrame;
using Cosmos.ServiceProvider;
using Cosmos.Common;
using Cosmos.CommonManager;
using System.Data;

/*-----------------------------------------------------------------------------------------------*/
// 설      명 : SPC 임직원 할인
// 작  성  자 : 
// 변경  이력 : 
/*-----------------------------------------------------------------------------------------------*/
namespace Cosmos.Service
{
    class SPCEmployeeDC : PaymentBase, IPaymentUs
    {

        public SPCEmployeeDC()
        {
        }

        #region SearchPayment 결제 조회
        /// <summary>
        /// 결제 조회
        /// </summary>
        /// <param name="aParam"></param>
        /// <param name="aRet"></param>
        /// <returns></returns>
        public string SearchPayment(string[] aParam, ref string[] aRet)
        {
            string sRet = UserCom.RST_ERR;
            string sInPutData = "", sCardData = "";
            try
            {
                sInPutData = aParam[2];                      // 입력데이터
                sCardData = aParam[3];                       // 카드데이터
                
                string sPosMenuKey = aParam[0];                     // 메뉴키
                string sInPutType = aParam[1];                      // 입력구분

                double nPayAmt = CmUtil.DoubleParse(aParam[4]);     // 대상금액

                string sTrType = PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_QRY_A;
                string sPointType = GetMenuKeyToPointType(sPosMenuKey);

                m_cPayItem = new Column.TR_PAYMENT.DATA();      // 결과 저장 변수 생성

                m_cPayItem.PAY_WAY_CD = GetMenuKeyToPayWayCd(sPosMenuKey);
                m_cPayItem.PAY_DTL_CD_01 = GetMenuKeyToPayDtlCd(sPosMenuKey);

                sRet = ExecuteIrt(PosConst.CANCEL_DIV.NORMAL, sTrType, sPointType, sInPutType, sInPutData, sCardData, nPayAmt, "", "");
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sCardData);
                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region GetPayment 결제 정보 획득
        /// <summary>
        /// 결제 정보 획득
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public object GetPayment(string[] aParam)
        {
            return m_cPayItem;
        }
        #endregion

        #region SetPayment 결제 등록
        /// <summary>
        /// 결제 등록(SPC 임직원 할인)
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string SetPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            string sCardData = "", sInPutData = "";

            try
            {

                sInPutData = aParam[2];                      // 입력데이터
                sCardData = aParam[3];                       // 카드데이터

                string sPosMenuKey = aParam[0];                     // 메뉴키
                string sInPutType = aParam[1];                      // 입력구분

                double nPayAmt = CmUtil.DoubleParse(aParam[4]);     // 대상금액
                string sApprDate = aParam[5];                       // 승인일자
                string sApprNo = aParam[6];                         // 승인번호

                string sCardNo_Can = aParam[7];                     // 일반카드번호

                if (sApprDate.Length == 8) sApprDate = CmUtil.MidH(sApprDate, 2, 6);   // 승인일자(YYMMDD)

                string sTrType = "";
                if (m_cTrnStatus.Head.TradeDiv == ItemConst.TRAN_DIV.NORMAL)
                    sTrType = PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_DIS_A;
                else
                    sTrType = PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_DIS_C;

                string sPointType = GetMenuKeyToPointType(sPosMenuKey);

                m_cPayItem = new Column.TR_PAYMENT.DATA();      // 결과 저장 변수 생성

                m_cPayItem.PAY_WAY_CD = GetMenuKeyToPayWayCd(sPosMenuKey);
                m_cPayItem.PAY_DTL_CD_01 = GetMenuKeyToPayDtlCd(sPosMenuKey);

                sRet = ExecuteIrt(PosConst.CANCEL_DIV.NORMAL, sTrType, sPointType, sInPutType, sInPutData, sCardData, nPayAmt, sApprDate, sApprNo);
                if (sRet != UserCom.RST_OK) return sRet;

                m_cPayItem.OCCUR_ENTRY_14 = sCardNo_Can;
                //m_cPayItem.CanFiller1 = sCardData;

                string sInEncData = "";
                string sMaskData = "";
                sInPutData = sCardNo_Can;
                EncryptedCardNo(sInPutData, ref sMaskData, ref sInEncData);
                m_cPayItem.CanFiller1 = sInEncData;

                // 결제 아이템 추가
                ArrayList alPayItem = (ArrayList)StateObject.GetItemObject(Column.TR_PAYMENT.ITEM);     // 결제 내역 받아 오기
                m_cPayItem.SEQ = alPayItem.Count + 1;
                alPayItem.Add(m_cPayItem);

                if (m_cPayItem.PAY_DTL_CD_05 == PosConst.PAY_DC_TYPE.DC)
                {
                    SetPluCoopDcAmount(m_cPayItem.PAY_WAY_CD + m_cPayItem.PAY_DTL_CD_01, m_cPayItem.PAY_AMT, nPayAmt);   // 상품아이템에 할인금액 설정
                }
                m_cDataService.UpdatePluAmount();       // 상품 합계금액 계산(거래해더)
                m_cDataService.UpdatePayAmount();       // 결제 금액 재 계산 처리

                //WinManager.ConfirmMessage(sPointType + " " + MessageManager.GetErrorMessage(POS_MESSAGE.ERROR.MSG_0067));
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sCardData);
                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region CancelPayment 결제 취소
        /// <summary>
        /// 결제 취소
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string CancelPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            string sCardData = "", sInPutData = "";

            try
            {
                if (m_cTrnStatus.Head.TradeDiv != ItemConst.TRAN_DIV.NORMAL) return sRet;

                int nPayRow = CmUtil.IntParse(aParam[0]); // 취소할 행번호

                // 결제 내역 받아 오기
                ArrayList alPayItem = (ArrayList)StateObject.GetItemObject(Column.TR_PAYMENT.ITEM);
                m_cPayItem = (Column.TR_PAYMENT.DATA)alPayItem[nPayRow];

                //sInPutData = m_cPayItem.OCCUR_ENTRY_01;          // 입력데이터
                sInPutData = m_cPayItem.OCCUR_ENTRY_14;          // 입력데이터
                //sCardData = m_cPayItem.CanFiller1;           // 카드데이터

                string sMaskData = "";
                EncryptedCardNo(sInPutData, ref sMaskData, ref sCardData);
                
                string sInPutType = m_cPayItem.OCCUR_ENTRY_05;          // 입력구분
                double nPayAmt = m_cPayItem.AMT_ENTRY_06;               // 대상금액
                string sApprDate = m_cPayItem.OCCUR_ENTRY_03;           // 승인일자
                string sApprNo = m_cPayItem.OCCUR_ENTRY_02;             // 승인번호

                string sTrType = PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_DIS_C;
                string sPointType = GetPayDtlCdToPointType(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01);

                sRet = ExecuteIrt(PosConst.CANCEL_DIV.CANCEL, sTrType, sPointType, sInPutType, sInPutData, sCardData, nPayAmt, sApprDate, sApprNo);
                if (sRet != UserCom.RST_OK) return sRet;

                if (m_cPayItem.PAY_DTL_CD_05 == PosConst.PAY_DC_TYPE.DC)
                {
                    ClearPluCoopDcAmount();        // 할인금액 삭제
                }

                m_cPayItem.CANCEL_DIV = PosConst.CANCEL_DIV.CANCEL;

                m_cDataService.UpdatePluAmount();       // 상품 합계금액 계산(거래해더)
                m_cDataService.UpdatePayAmount();       // 결제 금액 재 계산 처리

                //WinManager.ConfirmMessage(sPointType + " " + MessageManager.GetErrorMessage(POS_MESSAGE.ERROR.MSG_0068));

                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sCardData);
                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region RefundPayment 결제 반품
        /// <summary>
        /// 결제 반품
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string RefundPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            string sCardData = "", sInPutData = "";

            try
            {
                int nPayRow = CmUtil.IntParse(aParam[0]); // 취소할 행번호

                // 결제 내역 받아 오기
                ArrayList alPayItem = (ArrayList)StateObject.GetItemObject(Column.TR_PAYMENT.ITEM);
                m_cPayItem = (Column.TR_PAYMENT.DATA)alPayItem[nPayRow];

                if (m_cPayItem.OCCUR_ENTRY_08.ToString() != ItemConst.PAY_APP_DIV.NORMAL)
                {
                    //임의 등록 이면 승인 없이 데이터 처리
                    //WinManager.ConfirmMessage(MessageManager.GetErrorMessage(POS_MESSAGE.ERROR.MSG_0240));
                    m_cPayItem.OCCUR_ENTRY_06 = m_cPayItem.OCCUR_ENTRY_02;
                    m_cPayItem.OCCUR_ENTRY_07 = m_cPayItem.OCCUR_ENTRY_03;

                    sRet = UserCom.RST_OK;
                }
                else
                {
                    //sInPutData = m_cPayItem.OCCUR_ENTRY_01;          // 입력데이터
                    sInPutData = m_cPayItem.OCCUR_ENTRY_14;          // 입력데이터
                    //sCardData = m_cPayItem.CanFiller1;           // 카드데이터
                    string sMaskData = "";
                    EncryptedCardNo(sInPutData, ref sMaskData, ref sCardData);
                    //sCardData = m_cPayItem.OCCUR_ENTRY_22;           // 카드데이터

                    string sInPutType = m_cPayItem.OCCUR_ENTRY_05;          // 입력구분
                    double nPayAmt = m_cPayItem.AMT_ENTRY_06;               // 대상금액
                    string sApprDate = m_cPayItem.OCCUR_ENTRY_03;           // 승인일자
                    string sApprNo = m_cPayItem.OCCUR_ENTRY_02;             // 승인번호

                    string sTrType = PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_DIS_C;
                    string sPointType = GetPayDtlCdToPointType(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01);

                    sRet = ExecuteIrt(PosConst.CANCEL_DIV.CANCEL, sTrType, sPointType, sInPutType, sInPutData, sCardData, nPayAmt, sApprDate, sApprNo);
                    if (sRet != UserCom.RST_OK) return sRet;

                    //ClearPluCoopDcAmount();        // 할인금액 삭제
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sCardData);
                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region SetMenualPayment
        public string SetMenualPayment(string[] aParam)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region 조회 실행
        /// <summary>
        /// 조회 실행
        /// </summary>
        public string ExecuteIrt(string sTradeDiv, string sTrType, string sPointType, string sInPutType, string sInPutData, string sCardData, double nPayAmt, string sApprDate, string sApprNo)
        {
            string sRet = UserCom.RST_ERR;
            try
            {
                // 연습모드이면 연습 데이터 설정
                if (m_cPosStatus.Base.TrainingFlag == "1" || m_cPosStatus.Mst.TestStorYn == "1" ) return SetTrainingData(sTrType, sPointType, sInPutType, sInPutData, sCardData, nPayAmt, sApprDate, sApprNo);

                string sReserved = "";
                if (sTrType == PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_QRY_A || sTrType == PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_DIS_A || sTrType == PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_DIS_C)
                {
                    // 조회, 할인, 할인취소시
                    if (sPointType == "SPC")
                    {
                        sReserved += CmUtil.MidH(m_cPosStatus.Base.StoreNo, 0, 38);    // 점포코드
                        //sReserved += m_cPosStatus.Base.StoreNo;    // 점포코드
                    }
                }

                // 승인업체 코드 조회
                string sVanCD = PosMstManager.GetMstPayDc(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01, PosMst.MST_PAY_DC.DATA.APPR_VEND_CD);
                if (sVanCD == "")
                {
                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0563);
                    return sRet;
                }

                // 포인트 조회
                string[] aIrtRsp = null;
                sRet = ExecutePointIrt(sTradeDiv, m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01, sVanCD, sTrType, sPointType, sInPutType, sInPutData, sCardData, nPayAmt, sApprDate, sApprNo, "", "", sReserved, "", "", ref aIrtRsp, "", "");
                if (sRet != UserCom.RST_OK) return sRet;

                m_cPayItem.PAY_AMT = CmUtil.DoubleParse(aIrtRsp[Column.POS_RES_POINT.SEQ.ResTrPoint]); 

                m_cPayItem.PAY_DTL_CD_02 = "";      // 캠페인코드
                m_cPayItem.PAY_DTL_CD_03 = "0";     // 할인금액 아이템 적용여부 
                m_cPayItem.PAY_DTL_CD_05 = PosConst.PAY_DC_TYPE.PAY;            // 할인결제구분 (1:결제, 2:할인)
                if (PosMstManager.GetMstPayDc(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01, PosMst.MST_PAY_DC.DATA.PAY_DC_TYPE) == PosConst.PAY_DC_TYPE.DC)
                {
                    m_cPayItem.PAY_DTL_CD_03 = "1";                             // 할인금액아이템적용여부 (0:미적용, 1:적용)
                    m_cPayItem.PAY_DTL_CD_05 = PosConst.PAY_DC_TYPE.DC;         // 할인결제구분 (1:결제, 2:할인)
                }

                m_cPayItem.AMT_ENTRY_01 = CmUtil.DoubleParse(aIrtRsp[Column.POS_RES_POINT.SEQ.ResTrPoint]);       // 사용포인트
                m_cPayItem.AMT_ENTRY_02 = 0;                                                                      // 제휴 할인 금액
                m_cPayItem.AMT_ENTRY_03 = CmUtil.DoubleParse(aIrtRsp[Column.POS_RES_POINT.SEQ.ResSavePoint]);     // 총포인트
                m_cPayItem.AMT_ENTRY_04 = CmUtil.DoubleParse(aIrtRsp[Column.POS_RES_POINT.SEQ.ResUsesPoint]);     // 가용포인트(할인후결제금액)
                m_cPayItem.AMT_ENTRY_05 = CmUtil.DoubleParse(aIrtRsp[Column.POS_RES_POINT.SEQ.ResSparePoint]);
                m_cPayItem.AMT_ENTRY_06 = nPayAmt;                                                                  // 대상금액

                m_cPayItem.OCCUR_ENTRY_01 = sInPutData;         // 카드번호
                m_cPayItem.OCCUR_ENTRY_02 = aIrtRsp[Column.POS_RES_POINT.SEQ.ResApprNo].Trim();                 // 승인번호
                m_cPayItem.OCCUR_ENTRY_03 = CmUtil.MidH(aIrtRsp[Column.POS_RES_POINT.SEQ.ResTrDate], 0, 6);     // 승인일자
                m_cPayItem.OCCUR_ENTRY_04 = CmUtil.MidH(aIrtRsp[Column.POS_RES_POINT.SEQ.ResTrDate], 6, 4);     // 승인시간
                m_cPayItem.OCCUR_ENTRY_05 = sInPutType;         // 입력 구분
                m_cPayItem.OCCUR_ENTRY_06 = sApprNo;            // 원승인번호
                m_cPayItem.OCCUR_ENTRY_07 = sApprDate;          // 원승인일자
                m_cPayItem.OCCUR_ENTRY_08 = ItemConst.PAY_APP_DIV.NORMAL;                                               // 승인구분
                m_cPayItem.OCCUR_ENTRY_16 = sVanCD;             // VAN 구분
                m_cPayItem.OCCUR_ENTRY_20 = GetPayDtlCdToPayDtlName(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01);   // 결제수단명
                m_cPayItem.OCCUR_ENTRY_22 = "";

                m_cPayItem.CANCEL_DIV = ItemConst.PAY_CANCEL_DIV.NORMAL;
                m_cPayItem.BILLSPR_NO = m_cTrnStatus.Sale.BillSplitNo;              // 빌분리 번호
                 
                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sCardData);             
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }

        /// <summary>
        /// 연습 데이터 설정
        /// </summary>
        public string SetTrainingData(string sTrType, string sPointType, string sInPutType, string sInPutData, string sCardData, double nPayAmt, string sApprDate, string sApprNo)
        {
            string sRet = UserCom.RST_ERR;
            try
            {
                string sVanCD = PosMstManager.GetMstPayDc(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01, PosMst.MST_PAY_DC.DATA.APPR_VEND_CD);    // 승인업체 코드 조회
                if (sVanCD == "")
                {
                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0563);
                    return sRet;
                }

                // 연습모드이면 연습 데이터 설정
                m_cPayItem.PAY_AMT = nPayAmt;
                
                m_cPayItem.PAY_DTL_CD_02 = "";          // 캠페인코드
                m_cPayItem.PAY_DTL_CD_03 = "1";         // 할인금액 아이템 적용여부
                m_cPayItem.PAY_DTL_CD_05 = PosConst.PAY_DC_TYPE.DC;         // 할인결제구분 (1:결제, 2:할인)

                m_cPayItem.AMT_ENTRY_01 = nPayAmt;      // 사용포인트
                m_cPayItem.AMT_ENTRY_02 = 0;            // 제휴 할인 금액
                m_cPayItem.AMT_ENTRY_03 = 0;            // 총포인트
                m_cPayItem.AMT_ENTRY_04 = 0;            // 가용포인트
                m_cPayItem.AMT_ENTRY_05 = 0;            // 잔여포인트
                m_cPayItem.AMT_ENTRY_08 = 0;

                m_cPayItem.OCCUR_ENTRY_01 = sInPutData;                         // 카드번호
                m_cPayItem.OCCUR_ENTRY_02 = "99999999";                         // 승인번호
                m_cPayItem.OCCUR_ENTRY_03 = DateTime.Now.ToString("yyMMdd");    // 승인일자
                m_cPayItem.OCCUR_ENTRY_04 = DateTime.Now.ToString("HHmm");      // 승인시간
                m_cPayItem.OCCUR_ENTRY_05 = sInPutType;         // 입력 구분
                m_cPayItem.OCCUR_ENTRY_06 = sApprNo;            // 원승인번호
                m_cPayItem.OCCUR_ENTRY_07 = sApprDate;          // 원승인일자
                m_cPayItem.OCCUR_ENTRY_08 = ItemConst.PAY_APP_DIV.COMPULSION;   //승인구분
                m_cPayItem.OCCUR_ENTRY_16 = sVanCD;             // VAN 구분
                m_cPayItem.OCCUR_ENTRY_20 = GetPayDtlCdToPayDtlName(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01);   // 결제수단명
                m_cPayItem.OCCUR_ENTRY_22 = sCardData;

                m_cPayItem.CANCEL_DIV = ItemConst.PAY_CANCEL_DIV.NORMAL;
                m_cPayItem.BILLSPR_NO = m_cTrnStatus.Sale.BillSplitNo;              // 빌분리 번호

                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sCardData);             
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region 할인 금액 설정
        /// <summary>
        /// 상품별 할인 금액 설정
        /// </summary>
        /// <param name="sCoopDcDiv"></param>
        /// <param name="nTotDcAmt"></param>
        /// <param name="nTotSaleAmt"></param>
        /// <returns></returns>
        public double SetPluCoopDcAmount(string sCoopDcDiv, double nTotDcAmt, double nTotSaleAmt)
        {
            double nApplyAmt = 0, nDisAmt = 0, nMaxAmt = 0;
            int nMaxRow = 0;

            try
            {
                ArrayList alSaleItem = (ArrayList)StateObject.GetItemObject(Column.TR_PLU.ITEM);

                //nTotSaleAmt = 0;
                //for (int i = 0; i < alSaleItem.Count; i++)
                //{
                //    Column.TR_PLU.DATA cPluItem = (Column.TR_PLU.DATA)alSaleItem[i];

                //    if (cPluItem.CANCEL_DIV == PosConst.CANCEL_DIV.CANCEL || cPluItem.CANCEL_DIV_MAIN == PosConst.CANCEL_DIV.CANCEL) continue;    // 지정취소
                //    if (cPluItem.DC_PRMT_YN != "0") continue;

                //    nTotSaleAmt = CmUtil.DoubleAdd(nTotSaleAmt, cPluItem.BILL_AMT);
                //}

                for (int i = 0; i < alSaleItem.Count; i++)
                {
                    Column.TR_PLU.DATA cPluItem = (Column.TR_PLU.DATA)alSaleItem[i];

                    if (cPluItem.CANCEL_DIV == PosConst.CANCEL_DIV.CANCEL || cPluItem.CANCEL_DIV_MAIN == PosConst.CANCEL_DIV.CANCEL) continue;    // 지정취소
                    if (cPluItem.DC_PRMT_YN != "0") continue;
                    if (cPluItem.EMP_DC_AMT > 0) continue;

                    nTotDcAmt = CmUtil.MathRounds(nTotDcAmt, m_cPosStatus.Mst.DcRudDwLocMethd, CmUtil.IntParse(m_cPosStatus.Mst.DcRudDwLoc));
                    nDisAmt = CmUtil.DoubleMultiplication(nTotDcAmt, CmUtil.DoubleDivision(cPluItem.BILL_AMT, nTotSaleAmt));
                    nDisAmt = CmUtil.MathRounds(nDisAmt, m_cPosStatus.Mst.ItemRudDwLocMethd, CmUtil.IntParse(m_cPosStatus.Mst.ItemRudDwLoc));

                    cPluItem.EMP_DC_DIV = sCoopDcDiv;
                    cPluItem.EMP_DC_AMT = nDisAmt;

                    m_cDataService.UpdatePluItemAmount(cPluItem);

                    nApplyAmt = CmUtil.DoubleAdd(nApplyAmt, nDisAmt);
                    if (nMaxAmt == 0 || nMaxAmt < cPluItem.BILL_AMT)
                    {
                        nMaxAmt = cPluItem.BILL_AMT;
                        nMaxRow = i;
                    }
                }

                // 자투리 금액 
                if (nTotDcAmt != nApplyAmt)
                {
                    Column.TR_PLU.DATA cPluItem = (Column.TR_PLU.DATA)alSaleItem[nMaxRow];

                    cPluItem.EMP_DC_AMT = CmUtil.DoubleAdd(cPluItem.EMP_DC_AMT, CmUtil.DoubleSubtraction(nTotDcAmt, nApplyAmt));

                    m_cDataService.UpdatePluItemAmount(cPluItem);
                }

            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return nTotDcAmt;
        }

        /// <summary>
        /// 상품별 할인 금액 삭제
        /// </summary>
        /// <returns></returns>
        public double ClearPluCoopDcAmount()
        {
            try
            {
                ArrayList alSaleItem = (ArrayList)StateObject.GetItemObject(Column.TR_PLU.ITEM);

                for (int i = 0; i < alSaleItem.Count; i++)
                {
                    Column.TR_PLU.DATA cPluItem = (Column.TR_PLU.DATA)alSaleItem[i];

                    if (cPluItem.CANCEL_DIV == PosConst.CANCEL_DIV.CANCEL || cPluItem.CANCEL_DIV_MAIN == PosConst.CANCEL_DIV.CANCEL) continue;    // 지정취소
                    if (cPluItem.DC_PRMT_YN != "0") continue;
                    if (cPluItem.EMP_DC_AMT <= 0) continue;

                    cPluItem.EMP_DC_DIV = "0000";
                    cPluItem.EMP_DC_AMT = 0;

                    m_cDataService.UpdatePluItemAmount(cPluItem);
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return 0;
        }
        #endregion

        
    }
}
